class Counter implements Runnable {

    private int currentValue;

    private Thread worker;

    public Counter(String threadName) {
        currentValue = 0;
        worker = new Thread(this, threadName);   // (1) Create a new thread
        System.out.println(worker);
        worker.start();                          // (2) Start the thread
    }

    public int getValue() { return currentValue; }

    public void run() {                          // (3) Thread entry point
            while (currentValue < 5) {
                System.out.println(worker.getName() + ": " + (currentValue++));
                Thread.currentThread().yield(); //Thread.sleep(500);               // (4) Current thread sleeps
            }

        System.out.println("Exit from " + worker.getName() + ".");
    }
}

public class ThreadCreator {
    public static void main(String[] args) {
        Counter counterA = new Counter("Counter A"); // (5) Create a thread

        Counter counterB = new Counter("Counter B"); // (5) Create a thread
        Counter counterC = new Counter("Counter C"); // (5) Create a thread
        Counter counterD = new Counter("Counter D"); // (5) Create a thread

        try {
            int val;
            do {
                val = counterA.getValue();       // (6) Access the counter value
                System.out.println("Main Thread: " + val);
                Thread.sleep(0);              // (7) Current thread sleeps
            } while (val < 5);
        } catch (InterruptedException e) {
            System.out.println("Main Thread interrupted.");
        }

        System.out.println("Exit from Main Thread.");
    }
}
